searchNodes=[{"type":"module","title":"simdjson","doc":"Fast decoding of JSON using simdjson C++ library. By default JSON decoder uses the atom null to represent JSON nulls. To modify this behavior, set the following configuration option to another atom value (e.g. nil for Elixir): { simdjsone , [ { null , nil } ] } . See also https://github.com/simdjson/simdjson","ref":"simdjson.html"},{"type":"function","title":"simdjson.decode/1","doc":"Decode a JSON string or binary to a term representation of JSON.","ref":"simdjson.html#decode/1"},{"type":"function","title":"simdjson.decode/2","doc":"Decode a JSON string or binary to a term representation of JSON.","ref":"simdjson.html#decode/2"},{"type":"function","title":"simdjson.encode/1","doc":"Encode a term to a JSON string.","ref":"simdjson.html#encode/1"},{"type":"function","title":"simdjson.encode/2","doc":"","ref":"simdjson.html#encode/2"},{"type":"function","title":"simdjson.get/2","doc":"Find a given Path (which must start with a slash) in the JSON resource. The resource reference must have been previously created by calling parse/1,2 .","ref":"simdjson.html#get/2"},{"type":"function","title":"simdjson.get/3","doc":"Find a given Path (which must start with a slash) in the JSON resource. The resource reference must have been previously created by calling parse/1,2 .","ref":"simdjson.html#get/3"},{"type":"function","title":"simdjson.int_to_bin/1","doc":"Fast integer to binary conversion","ref":"simdjson.html#int_to_bin/1"},{"type":"function","title":"simdjson.minify/1","doc":"Minify a JSON string or binary.","ref":"simdjson.html#minify/1"},{"type":"function","title":"simdjson.parse/1","doc":"Parse a JSON string or binary and save it in a resource for later access by get/2 . Returns a resource reference owned by the calling pid.","ref":"simdjson.html#parse/1"},{"type":"type","title":"simdjson.decode_opt/0","doc":"","ref":"simdjson.html#t:decode_opt/0"},{"type":"type","title":"simdjson.decode_opts/0","doc":"Decode options: return_maps - decode JSON object as map object_as_tuple - decode JSON object as a proplist wrapped in a tuple dedup_keys - eliminate duplicate keys from a JSON object use_nil - decode JSON &quot;null&quot; as nil {null_term, V} - use the given value V for a JSON &quot;null&quot;","ref":"simdjson.html#t:decode_opts/0"},{"type":"type","title":"simdjson.encode_opt/0","doc":"","ref":"simdjson.html#t:encode_opt/0"},{"type":"type","title":"simdjson.encode_opts/0","doc":"Encode options: uescape - escape UTF-8 sequences to produce a 7-bit clean output pretty - return JSON using two-space indentation use_nil - encode the atom nil as null`&lt;/li&gt; &lt;li&gt;`escape_fwd_slash - escape the / character (useful when encoding URLs) {bytes_per_red, N} - where N &gt;= 0 - This controls the number of bytes that Jiffy will process as an equivalent to a reduction. Each 20 reductions we consume 1% of our allocated time slice for the current process. When the Erlang VM indicates we need to return from the NIF.","ref":"simdjson.html#t:encode_opts/0"},{"type":"extras","title":"Overview","doc":"An implementation of the fastest JSON parser for Erlang/Elixir using the C++ simdjson NIF library. The decoding speed of this parser is about 2.5 times faster than jiffy . See full documentation of the C++ library. Only a subset of functionality is implemented: Ability to decode JSON terms using a main scheduler or a dirty scheduler based on the size of JSON binary input. Ability to cache the decoded term, and access its key/value pairs using a NIF based simdjson:get/2 function. The resources stored in the cache will get automatically garbage collected when the owner process dies. For small JSON objects simdjsone is about twice faster than jiffy and for large JSON objects, it's about 30% faster than jiffy . Decoding The following decoding options are supported in decode(String, Options) : return_maps - decode JSON object as map (this is default) object_as_tuple - decode JSON object as a proplist wrapped in a tuple dedup_keys - eliminate duplicate keys from a JSON object use_nil - decode JSON &quot;null&quot; as nil {null_term, V} - use the given value V for a JSON &quot;null&quot; Encoding The following decoding options are supported in encode(String, Options) : uescape - escape UTF-8 sequences to produce a 7-bit clean output pretty - return JSON using two-space indentation use_nil - encode the atom nil as null escape_fwd_slash - escape the / character (useful when encoding URLs) {bytes_per_red, N} - where N &gt;= 0 - This controls the number of bytes that Jiffy will process as an equivalent to a reduction. Each 20 reductions we consume 1% of our allocated time slice for the current process. When the Erlang VM indicates we need to return from the NIF. NOTE : Since the simdjson library currently doen't have an implementation of a JSON encoder, the encoding implementation is the jiffy's modified encoder optimized for encoding integers. The implementation includes simdjson:int_to_bin/1 function that is about 30% faster than erlang:integer_to_binary/1 , but it's limited to integers in range: (-1 bsl 63) &lt;= I &lt;= (1 bsl 62) .","ref":"readme.html"},{"type":"extras","title":"Overview - Author","doc":"Serge Aleynikov","ref":"readme.html#author"},{"type":"extras","title":"Overview - Installation","doc":"Include the following dependency in your project. Erlang ( rebar.config ): { deps , [ { simdjsone , &quot;0.1&quot; } ] } . Elixir ( mix.exs ): def deps ( ) do [ { :simdjsone , &quot;~&gt; 0.2&quot; } ] end","ref":"readme.html#installation"},{"type":"extras","title":"Overview - Build","doc":"Erlang: $ make deps compile Elixir $ MIX_ENV=dev make deps compile","ref":"readme.html#build"},{"type":"extras","title":"Overview - Simple JSON decoding","doc":"1 &gt; simdjson : decode ( &quot;{\\&quot;a\\&quot;: [1,2,3], \\&quot;b\\&quot;: 123, \\&quot;c\\&quot;: 12.234}&quot; ) . \#{ &lt;&lt; &quot;a&quot; &gt;&gt; =&gt; [ 1 , 2 , 3 ] , &lt;&lt; &quot;b&quot; &gt;&gt; =&gt; 123 , &lt;&lt; &quot;c&quot; &gt;&gt; =&gt; 12.234 }","ref":"readme.html#simple-json-decoding"},{"type":"extras","title":"Overview - Cached JSON decoding","doc":"After calling the simdjson:parse/1 , the function simdjson:get/2 returns the value stored in a given path: 1 &gt; Ref = simdjson : parse ( &quot;{\\&quot;a\\&quot;: [1,2,3], \\&quot;b\\&quot;: 123, \\&quot;c\\&quot;: 12.234}&quot; ) . # Ref &lt; 0.1852532992 . 2458255361.217635 &gt; 2 &gt; simdjson : get ( Ref , &quot;/a&quot; ) . [ 1 , 2 , 3 ] 3 &gt; simdjson : get ( Ref , &quot;/b&quot; ) . 123 4 &gt; simdjson : get ( Ref , &quot;/a/c&quot; ) . 12.234 ok","ref":"readme.html#cached-json-decoding"},{"type":"extras","title":"Overview - JSON encoding","doc":"1 &gt; simdjson : encode ( \#{ a =&gt; [ 1 , 2 , 3 ] , &lt;&lt; &quot;b&quot; &gt;&gt; =&gt; 123 , c =&gt; 12.234 } ) . &lt;&lt; &quot;{\\&quot;b\\&quot;:123,\\&quot;a\\&quot;:[1,2,3],\\&quot;c\\&quot;:12.234}&quot; &gt;&gt; 2 &gt; simdjson : encode ( { [ { a , [ 1 , 2 , 3 ] } , { &lt;&lt; &quot;b&quot; &gt;&gt; , 123 } , { c , 12.234 } ] } ) . &lt;&lt; &quot;{\\&quot;a\\&quot;:[1,2,3],\\&quot;b\\&quot;:123,\\&quot;c\\&quot;:12.234}&quot; &gt;&gt;","ref":"readme.html#json-encoding"},{"type":"extras","title":"Overview - Performance Benchmark","doc":"To run the performance benchmark of simdjsone against jiffy and thoas do the following (prefix the command with CXX=clang++ for using Clang C++ compiler): $ make benchmark === Benchmark (file size: 616.7K) === simdjsone: 5539.670us euneus: 8435.540us thoas: 8902.160us jiffy: 13688.250us === Benchmark (file size: 1.3K) === simdjsone: 8.030us jiffy: 14.950us thoas: 14.960us euneus: 19.830us === Benchmark (file size: 0.1K) === simdjsone: 1.530us jiffy: 2.700us euneus: 3.220us thoas: 3.600us If you have Elixir installed, the project also includes a benchmark for the jason and poison Elixir parsers. The Elixir benchmarks are more exhaustive: $ MIX_ENV=test make benchmark === Benchmark (file size: 616.7K) === Name ips average deviation median 99th % simdjsone 233.24 4.29 ms ±32.31% 4.34 ms 10.19 ms jason 160.87 6.22 ms ±4.83% 6.14 ms 7.50 ms poison 158.17 6.32 ms ±7.06% 6.20 ms 8.67 ms euneus 156.35 6.40 ms ±8.01% 6.26 ms 8.47 ms thaos 138.75 7.21 ms ±15.95% 6.81 ms 11.96 ms jiffy 83.03 12.04 ms ±6.64% 12.10 ms 13.98 ms Comparison: simdjsone 233.24 jason 160.87 - 1.45x slower +1.93 ms poison 158.17 - 1.47x slower +2.03 ms euneus 156.35 - 1.49x slower +2.11 ms thaos 138.75 - 1.68x slower +2.92 ms jiffy 83.03 - 2.81x slower +7.76 ms Memory usage statistics: Name Memory usage simdjsone 0.00153 MB jason 1.81 MB - 1188.30x memory usage +1.81 MB poison 1.84 MB - 1206.10x memory usage +1.84 MB euneus 1.87 MB - 1225.57x memory usage +1.87 MB thaos 1.81 MB - 1188.19x memory usage +1.81 MB jiffy 3.19 MB - 2088.37x memory usage +3.19 MB **All measurements for memory usage were the same** === Benchmark (file size: 1.3K) === Name ips average deviation median 99th % simdjsone 128.43 K 7.79 μs ±468.75% 5.60 μs 21.10 μs euneus 106.19 K 9.42 μs ±87.91% 8.80 μs 21.40 μs poison 97.80 K 10.23 μs ±74.31% 9.30 μs 23 μs jason 96.92 K 10.32 μs ±98.77% 9.50 μs 26.30 μs jiffy 90.31 K 11.07 μs ±97.74% 9.20 μs 45.30 μs thaos 79.04 K 12.65 μs ±133.82% 11.50 μs 26.70 μs Comparison: simdjsone 128.43 K euneus 106.19 K - 1.21x slower +1.63 μs poison 97.80 K - 1.31x slower +2.44 μs jason 96.92 K - 1.33x slower +2.53 μs jiffy 90.31 K - 1.42x slower +3.29 μs thaos 79.04 K - 1.62x slower +4.87 μs Memory usage statistics: Name Memory usage simdjsone 1.55 KB euneus 5.22 KB - 3.36x memory usage +3.66 KB poison 5.57 KB - 3.58x memory usage +4.02 KB jason 5.29 KB - 3.40x memory usage +3.73 KB jiffy 1.55 KB - 1.00x memory usage +0 KB thaos 5.08 KB - 3.27x memory usage +3.52 KB **All measurements for memory usage were the same** === Benchmark (file size: 0.1K) === Name ips average deviation median 99th % simdjsone 695.44 K 1.44 μs ±2134.49% 1.10 μs 3.40 μs poison 613.54 K 1.63 μs ±1373.87% 1.40 μs 3.60 μs euneus 515.85 K 1.94 μs ±1023.18% 1.70 μs 4.20 μs thaos 497.72 K 2.01 μs ±665.35% 1.80 μs 4.40 μs jason 425.55 K 2.35 μs ±816.21% 2 μs 6.10 μs jiffy 327.46 K 3.05 μs ±774.79% 2.50 μs 7.90 μs Comparison: simdjsone 695.44 K poison 613.54 K - 1.13x slower +0.192 μs euneus 515.85 K - 1.35x slower +0.50 μs thaos 497.72 K - 1.40x slower +0.57 μs jason 425.55 K - 1.63x slower +0.91 μs jiffy 327.46 K - 2.12x slower +1.62 μs Memory usage statistics: Name Memory usage simdjsone 0.59 KB poison 1.32 KB - 2.22x memory usage +0.73 KB euneus 1.20 KB - 2.03x memory usage +0.61 KB thaos 1.20 KB - 2.03x memory usage +0.61 KB jason 1.27 KB - 2.14x memory usage +0.68 KB jiffy 1.46 KB - 2.46x memory usage +0.87 KB","ref":"readme.html#performance-benchmark"},{"type":"extras","title":"Overview - TODO:","doc":"Add support for iterator Add support for iterate_many and parse_many","ref":"readme.html#todo"},{"type":"extras","title":"License","doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright [yyyy] [name of copyright owner] Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html"}]